/*	
 *	clipcoll.c
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2005 Naoyuki Sawa
 *
 *	* Mon Dec 26 01:25:00 JST 2005 Naoyuki Sawa
 *	- VK쐬B
 *	  R[hTCYߖ̂߂ɁAclipmisc.cclipcoll.c֕܂B
 */
#include "clip.h"

/*****************************************************************************
 *	[eBeBFRNṼwp֐
 *****************************************************************************/

void*
ptr_copy(void* a)
{
	/* |C^Ԃ܂B */
	return a;
}

void
ptr_delete(void* a)
{
	/* ܂B */
}

int
ptr_equals(void* a, void* b)
{
	/* |C^r܂B */
	return a == b;
}

void*
str_copy(void* a)
{
	/* 𕡐܂B */
	a = strdup(a);
	if(!a) {
		DIE();
	}
	return a;
}

void
str_delete(void* a)
{
	/* ܂B */
	free(a);
}

int
str_equals(void* a, void* b)
{
	/* r܂B */
	return strcmp(a, b) == 0;
}

void*
unk_copy(void* a)
{
	/* C^[tFCX|C^̎QƃJEg𑝂₵āAԂ܂B */
	UNKNOWN_INTERFACE** _a = a;
	return safe_addref(_a);
}

void
unk_delete(void* a)
{
	/* C^[tFCX|C^̎QƃJEg炵܂B */
	UNKNOWN_INTERFACE** _a = a;
	safe_release(_a);
}

int
unk_equals(void* a, void* b)
{
	/* * abقȂC^[tFCX|C^łĂA
	 *   IuWFNg̃C^[tFCX|C^ł΁AƌȂdlłB
	 * - q̔s߂ɂ́AMAPɊi[ĂUNKNOWN_INTERFACÊ܂ܔr̂łȂA
	 *   IUNKNOWN_INTERFACEvAԂꂽUNKNOWN_INTERFACEmrKv܂B
	 *   ȂȂAIuWFNg̃C^[tFCXĂꍇAeC^[tFCX
	 *   ꂼꂪUNKNOWN_INTERFACEł邽߁AUNKNOWN_INTERFACE݂邩łB
	 *   IUNKNOWN_INTERFACEv邱ƂŁAB̑\UNKNOWN_INTERFACE𓾂܂B
	 *   \UNKNOWN_INTERFACÉAIuWFNgɈӂłA\UNKNOWN_INTERFACEr΁A
	 *   IuWFNgꂩǂr邱Ƃł܂B
	 * - ȂAMAPւ̊i[unk_copy()ɂđ\UNKNOWN_INTERFACE߂Ă@͕słB
	 *   sł闝R̈ڂ́Â悤ȕ@̂ƁAMAPɊi[C^[tFCX|C^
	 *   ɑ\UNKNOWN_INTERFACEɂȂĂ܂Amap_put()map_get()̒lsvƂȂ邩łB
	 *   sł闝R̓ڂ́Aunk_equals()́AMAPɊi[Ălmap_contains()A
	 *   ܂́Amap_get()Ɏw肳ꂽlƂ̔rłAmap_contains()map_get()Ɏw肳ĺA
	 *   K\UNKNOWN_INTERFACEƂ͌ȂłB
	 * * Pȃ|C^rŗǂꍇ́Aunk_equals()̑ptr_equals()gĂB
	 */
	//int result;
	//UNKNOWN_INTERFACE** _a = a;
	//UNKNOWN_INTERFACE** _b = b;
	//_a = safe_query_interface(_a, UNKNOWN_INTERFACE); /* refcnt+1 */
	//_b = safe_query_interface(_b, UNKNOWN_INTERFACE); /* refcnt+1 */
	//result = _a == _b;
	//safe_release(_a); /* refcnt-1 */
	//safe_release(_b); /* refcnt-1 */
	//return result;
	//2005/12/13 reference_equals()}Ng悤ɕύX܂B̓e͓łB
	return reference_equals((UNKNOWN_INTERFACE**)a, (UNKNOWN_INTERFACE**)b);
}

/*****************************************************************************
 *	[eBeBF}bv (RNV)
 *****************************************************************************/

/* }bvvf܂B
 * [in]
 *	map		}bvB
 *	key		L[B
 * [out]
 *	߂l		ꍇ́A}bvvfԂ܂B
 *			Ȃꍇ́ANULLԂ܂B
 */
static MAP_ENTRY*
map_find(MAP* map, void* key)
{
	LIST_ENTRY* list_head = &map->list_head;
	LIST_ENTRY* list_entry = list_head->Flink;
	MAP_ENTRY* map_entry;

	/* Xg𑖍... */
	while(list_entry != list_head) {
		map_entry = CONTAINING_RECORD(list_entry, MAP_ENTRY, list_entry);
		if(map->map_info.key_equals(map_entry->key, key)) {
			/*{{̂߂̏: ̏͏ȗĂvłB*/
			/* ̂߂ɁA}bvvfXg擪ֈړ܂B
			 * ̂悤ȃp^[ł̎gpʓIƁA\邩łB
			 *	if(map_contains(map, key)) {
			 *		val = map_get(map, key);
			 *		...
			 *		free(val); // 2005/12/11̎dlύXɂAl̉KvƂȂ܂B
			 *	}
			 */
			RemoveEntryList(/*&map_entry->*/list_entry);
			InsertHeadList(&map->list_head, /*&map_entry->*/list_entry);
			/*}}̂߂̏: ̏͏ȗĂvłB*/
			return map_entry; /*  */
		}
		list_entry = list_entry->Flink;
	}

	return NULL; /* Ȃ */
}

/*---------------------------------------------------------------------------*/

MAP*
map_create(const MAP_INFO* map_info)
{
	/* \̃mۂ܂B */
	MAP* map = calloc(1, sizeof(MAP));
	if(!map) {
		DIE();
	}

	/* Xgwb_܂B */
	InitializeListHead(&map->list_head);

	/* }bvi[܂B */
	map->map_info = *map_info;

	return map;
}

void
map_delete(MAP* map)
{
	/* cĂ}bvvfׂč폜܂B */
	map_clear(map);

	/* \̃܂B */
	free(map);
}

void
map_clear(MAP* map)
{
	LIST_ENTRY* list_entry;
	MAP_ENTRY* map_entry;

	/* XgɂȂ܂... */
	while(!IsListEmpty(&map->list_head)) {

		/* 擪̃}bvvf擾AXgO܂B */
		list_entry = RemoveHeadList(&map->list_head);
		map_entry = CONTAINING_RECORD(list_entry, MAP_ENTRY, list_entry);

		/* }bvvf폜܂B */
		map->map_info.key_delete(map_entry->key); /* L[폜 */
		map->map_info.val_delete(map_entry->val); /* l  폜 */
		free(map_entry); /* }bvvf̃ */
	}
}

int
map_contains(MAP* map, void* key)
{
	/* }bvvfA1AȂ0Ԃ܂B */
	return map_find(map, key) != NULL;
}

void
map_put(MAP* map, void* key, void* val)
{
	MAP_ENTRY* map_entry;

	/* V}bvvf쐬܂B */
	map_entry = calloc(1, sizeof(MAP_ENTRY)); /* }bvvf̃m */
	if(!map_entry) {
		DIE();
	}
	map_entry->key = map->map_info.key_copy(key); /* L[𕡐Ċi[ */
	map_entry->val = map->map_info.val_copy(val); /* l  𕡐Ċi[ */

	/* L[Ã}bvvf΁A폜܂B */
	if(map_contains(map, key)) {
		map_remove(map, key); /* ̃}bvvf폜 */
	}

	/* V}bvvfAXgɒǉ܂B */
	InsertHeadList(&map->list_head, &map_entry->list_entry);
}

void*
map_get(MAP* map, void* key)
{
	MAP_ENTRY* map_entry;

	/* }bvvf܂B */
	map_entry = map_find(map, key);
	if(!map_entry) {
		DIE(); /* Ȃ */
	}

	///* }bvvf́AlԂ܂B */
	//return map_entry->val;
	//2005/12/11 dlύX
	/* }bvvfێĂl̕Ԃ܂B */
	return map->map_info.val_copy(map_entry->val);
}

void
map_remove(MAP* map, void* key)
{
	MAP_ENTRY* map_entry;

	/* 폜}bvvf܂B */
	map_entry = map_find(map, key);
	if(!map_entry) {
		DIE(); /* Ȃ */
	}

	/* 폜}bvvfAXgO܂B */
	RemoveEntryList(&map_entry->list_entry);

	/* }bvvf폜܂B */
	map->map_info.key_delete(map_entry->key); /* L[폜 */
	map->map_info.val_delete(map_entry->val); /* l  폜 */
	free(map_entry); /* }bvvf̃ */
}

MAP*
map_duplicate(MAP* map)
{
	LIST_ENTRY* list_head = &map->list_head; /* ̃}bṽXgwb_ */
	LIST_ENTRY* list_entry = list_head->Flink; /* ̃}bṽXgp */
	MAP_ENTRY* src_map_entry; /* ̃}bṽXgvf */
	MAP_ENTRY* dst_map_entry; /* ̃}bṽXgvf */

	/* ̃}bvƓ}bvÃ}bv쐬܂B
	 * ꂪÃ}bvƂȂ܂B
	 */
	map = map_create(&map->map_info); /* ȍ~Amap͕̃}bvw܂ */

	/* ̃}bv̊evf̒lɂ... */
	while(list_entry != list_head) {
		src_map_entry = CONTAINING_RECORD(list_entry, MAP_ENTRY, list_entry);

		/* key_copy()val_copy()wp֐pĕ... */
		dst_map_entry = calloc(1, sizeof(MAP_ENTRY)); /* }bvvf̃m */
		if(!dst_map_entry) {
			DIE();
		}
		dst_map_entry->key = map->map_info.key_copy(src_map_entry->key); /* L[𕡐Ċi[ */
		dst_map_entry->val = map->map_info.val_copy(src_map_entry->val); /* l  𕡐Ċi[ */

		/* ̃}bv֒ǉ܂B */
		InsertTailList(&map->list_head, &dst_map_entry->list_entry);

		list_entry = list_entry->Flink;
	}

	/* ̃}bvԂ܂B */
	return map;
}

struct _ARRAY*
map_keys(MAP* map)
{
	LIST_ENTRY* list_head = &map->list_head;
	LIST_ENTRY* list_entry = list_head->Flink;
	MAP_ENTRY* map_entry;
	//
	ARRAY* array;
	ARRAY_INFO array_info;

	/* ̉ϒz쐬܂B */
	array_info.val_copy = map->map_info.key_copy;
	array_info.val_delete = map->map_info.key_delete;
	array = array_create(&array_info);

	/* }bvvfɊ܂܂ĂAׂẴL[Aϒzɒǉ܂B */
	while(list_entry != list_head) {
		map_entry = CONTAINING_RECORD(list_entry, MAP_ENTRY, list_entry);
		array_add(array, map_entry->key);
		list_entry = list_entry->Flink;
	}

	return array;
}

/*****************************************************************************
 *	[eBeBFϒz (RNV)
 *****************************************************************************/

/* CfNXɂĎw肳ꂽʒúAϒzvf擾܂B
 * [in]
 *	array		ϒzB
 *	index		CfNXB
 * [out]
 *	߂l		ϒzvfB
 * [note]
 *	* CfNX́ALȈʒu(0ȏAzTCY)łȂ΂Ȃ܂B
 *	  ͈̔͊ÕCfNXw肳ꂽꍇ́AAT[g܂B
 *	  ̉ϒzɑ΂Ă̊֐Ăяoꍇ́AɃAT[g܂B
 */
static ARRAY_ENTRY*
array_get_entry(ARRAY* array, int index)
{
	LIST_ENTRY* list_head = &array->list_head;
	LIST_ENTRY* list_entry = list_head->Flink;
	ARRAY_ENTRY* array_entry;

	/* Xg𑖍... */
	while(list_entry != list_head) {
		if(!index) { /* CfNXv */
			array_entry = CONTAINING_RECORD(list_entry, ARRAY_ENTRY, list_entry);
			return array_entry;
		}
		index--; /* JEg_E */
		list_entry = list_entry->Flink;
	}

	DIE(); /* CfNXs */
}

/*---------------------------------------------------------------------------*/

ARRAY*
array_create(const ARRAY_INFO* array_info)
{
	/* \̃mۂ܂B */
	ARRAY* array = calloc(1, sizeof(ARRAY));
	if(!array) {
		DIE();
	}

	/* Xgwb_܂B */
	InitializeListHead(&array->list_head);

	/* ϒzi[܂B */
	array->array_info = *array_info;

	return array;
}

void
array_delete(ARRAY* array)
{
	/* cĂϒzvfׂč폜܂B */
	array_clear(array);

	/* \̃܂B */
	free(array);
}

void
array_clear(ARRAY* array)
{
	LIST_ENTRY* list_entry;
	ARRAY_ENTRY* array_entry;

	/* XgɂȂ܂... */
	while(!IsListEmpty(&array->list_head)) {

		/* 擪̉ϒzvf擾AXgO܂B */
		list_entry = RemoveHeadList(&array->list_head);
		array_entry = CONTAINING_RECORD(list_entry, ARRAY_ENTRY, list_entry);

		/* ϒzvf폜܂B */
		array->array_info.val_delete(array_entry->val); /* l폜 */
		free(array_entry); /* ϒzvf̃ */
	}
}

int
array_size(ARRAY* array)
{
	LIST_ENTRY* list_head = &array->list_head;
	LIST_ENTRY* list_entry = list_head->Flink;
	int size = 0;

	/* XgɓB܂... */
	while(list_entry != list_head) {
		size++; /* JEgAbv */
		list_entry = list_entry->Flink;
	}

	return size;
}

void
array_set(ARRAY* array, int index, void* val)
{
	/* CfNXɂĎw肳ꂽʒúA̒l폜܂B */
	array_remove(array, index);

	/* CfNXɂĎw肳ꂽʒuɁAVlǉ܂B */
	array_insert(array, index, val);
}

void*
array_get(ARRAY* array, int index)
{
	ARRAY_ENTRY* array_entry;

	/* ϒzvf擾܂B */
	array_entry = array_get_entry(array, index);

	/* ϒzvfێĂl̕Ԃ܂B */
	return array->array_info.val_copy(array_entry->val);
}

void
array_add(ARRAY* array, void* val)
{
	/* ϒz̖ɁAlǉ܂B */
	array_insert(array, array_size(array), val);
}

void
array_insert(ARRAY* array, int index, void* val)
{
	int size;
	ARRAY_ENTRY* array_entry;
	LIST_ENTRY* list_entry;
	LIST_ENTRY* next_list_entry;
	LIST_ENTRY* prev_list_entry;

	/* VϒzvfǉʒúAÕXgvf擾܂B */
	size = array_size(array);
	if(index == size) { /* ɒǉꍇ */
		next_list_entry = &array->list_head;
	} else { /* rɒǉꍇ */
		array_entry = array_get_entry(array, index); /* CfNXsȂ΁AŃAT[g܂ */
		next_list_entry = &array_entry->list_entry;
	}
	prev_list_entry = next_list_entry->Blink;

	/* Vϒzvf쐬܂B */
	array_entry = calloc(1, sizeof(ARRAY_ENTRY)); /* ϒzvf̃m */
	if(!array_entry) {
		DIE();
	}
	array_entry->val = array->array_info.val_copy(val); /* l𕡐Ċi[ */

	/* VϒzvfAXgɒǉ܂B */
	list_entry = &array_entry->list_entry;
	list_entry->Flink = next_list_entry;
	list_entry->Blink = prev_list_entry;
	prev_list_entry->Flink = next_list_entry->Blink = list_entry;
}

void
array_remove(ARRAY* array, int index)
{
	ARRAY_ENTRY* array_entry;

	/* 폜ϒzvf擾܂B */
	array_entry = array_get_entry(array, index);

	/* 폜ϒzvfAXgO܂B */
	RemoveEntryList(&array_entry->list_entry);

	/* ϒzvf폜܂B */
	array->array_info.val_delete(array_entry->val); /* l폜 */
	free(array_entry); /* ϒzvf̃ */
}

ARRAY*
array_duplicate(ARRAY* array)
{
	LIST_ENTRY* list_head = &array->list_head; /* ̉ϒz̃Xgwb_ */
	LIST_ENTRY* list_entry = list_head->Flink; /* ̉ϒz̃Xgp */
	ARRAY_ENTRY* src_array_entry; /* ̉ϒz̃Xgvf */
	ARRAY_ENTRY* dst_array_entry; /* ̉ϒz̃Xgvf */

	/* ̉ϒzƓϒzẢϒz쐬܂B
	 * ꂪẢϒzƂȂ܂B
	 */
	array = array_create(&array->array_info); /* ȍ~Aarraỷ͕ϒzw܂ */

	/* ̉ϒz̊evf̒lɂ... */
	while(list_entry != list_head) {
		src_array_entry = CONTAINING_RECORD(list_entry, ARRAY_ENTRY, list_entry);

		/* val_copy()wp֐pĕ... */
		dst_array_entry = calloc(1, sizeof(ARRAY_ENTRY)); /* ϒzvf̃m */
		if(!dst_array_entry) {
			DIE();
		}
		dst_array_entry->val = array->array_info.val_copy(src_array_entry->val); /* l𕡐Ċi[ */

		/* ̉ϒz֒ǉ܂B */
		InsertTailList(&array->list_head, &dst_array_entry->list_entry);

		list_entry = list_entry->Flink;
	}

	/* ̉ϒzԂ܂B */
	return array;
}

